Index: /trunk/src/bp-core/bp-core-buddybar.php
===================================================================
--- /trunk/src/bp-core/bp-core-buddybar.php	(revision 10744)
+++ /trunk/src/bp-core/bp-core-buddybar.php	(revision 10745)
@@ -14,7 +14,165 @@
 
 /**
- * Add an item to the main BuddyPress navigation array.
+ * Add an item to the primary navigation of the specified component.
  *
  * @since 1.1.0
+ * @since 2.6.0 Introduced the `$component` parameter.
+ *
+ * @param array|string $args {
+ *     Array describing the new nav item.
+ *     @type string      $name                    Display name for the nav item.
+ *     @type string      $slug                    Unique URL slug for the nav item.
+ *     @type bool|string $item_css_id             Optional. 'id' attribute for the nav item. Default: the value of `$slug`.
+ *     @type bool        $show_for_displayed_user Optional. Whether the nav item should be visible when viewing a
+ *                                                member profile other than your own. Default: true.
+ *     @type bool        $site_admin_only         Optional. Whether the nav item should be visible only to site admins
+ *                                                (those with the 'bp_moderate' cap). Default: false.
+ *     @type int         $position                Optional. Numerical index specifying where the item should appear in
+ *                                                the nav array. Default: 99.
+ *     @type callable    $screen_function         The callback function that will run when the nav item is clicked.
+ *     @type bool|string $default_subnav_slug     Optional. The slug of the default subnav item to select when the nav
+ *                                                item is clicked.
+ * }
+ * @param string $component The component the navigation is attached to. Defaults to 'members'.
+ * @return bool|null Returns false on failure.
+ */
+function bp_core_new_nav_item( $args, $component = 'members' ) {
+	if ( ! bp_is_active( $component ) ) {
+		return;
+	}
+
+	$defaults = array(
+		'name'                    => false, // Display name for the nav item.
+		'slug'                    => false, // URL slug for the nav item.
+		'item_css_id'             => false, // The CSS ID to apply to the HTML of the nav item.
+		'show_for_displayed_user' => true,  // When viewing another user does this nav item show up?
+		'site_admin_only'         => false, // Can only site admins see this nav item?
+		'position'                => 99,    // Index of where this nav item should be positioned.
+		'screen_function'         => false, // The name of the function to run when clicked.
+		'default_subnav_slug'     => false  // The slug of the default subnav item to select when clicked.
+	);
+
+	$r = wp_parse_args( $args, $defaults );
+
+	// Validate nav link data.
+	$nav_item = bp_core_create_nav_link( $r, $component );
+
+	/*
+	 * To mimic legacy behavior, if bp_core_create_nav_link() returns false, we make
+	 * an early exit and don't attempt to register the screen function.
+	 */
+	if ( false === $nav_item ) {
+		return false;
+	}
+
+	// Then, hook the screen function for the added nav item.
+	$hooked = bp_core_register_nav_screen_function( $nav_item );
+	if ( false === $hooked ){
+		return false;
+	}
+
+	/**
+	 * Fires after adding an item to the main BuddyPress navigation array.
+	 * Note that, when possible, the more specific action hooks
+	 * `bp_core_create_nav_link` or `bp_core_register_nav_screen_function`
+	 * should be used.
+	 *
+	 * @since 1.5.0
+	 *
+	 * @param array $r        Parsed arguments for the nav item.
+	 * @param array $args     Originally passed in arguments for the nav item.
+	 * @param array $defaults Default arguments for a nav item.
+	 */
+	do_action( 'bp_core_new_nav_item', $r, $args, $defaults );
+}
+
+/**
+ * Add a link to the main BuddyPress navigation.
+ *
+ * @since 2.4.0
+ * @since 2.6.0 Introduced the `$component` parameter. Began returning a BP_Nav_Item object on success.
+ *
+ * @param array|string $args {
+ *     Array describing the new nav item.
+ *     @type string      $name                    Display name for the nav item.
+ *     @type string      $slug                    Unique URL slug for the nav item.
+ *     @type bool|string $item_css_id             Optional. 'id' attribute for the nav item. Default: the value of `$slug`.
+ *     @type bool        $show_for_displayed_user Optional. Whether the nav item should be visible when viewing a
+ *                                                member profile other than your own. Default: true.
+ *     @type bool        $site_admin_only         Optional. Whether the nav item should be visible only to site admins
+ *                                                (those with the 'bp_moderate' cap). Default: false.
+ *     @type int         $position                Optional. Numerical index specifying where the item should appear in
+ *                                                the nav array. Default: 99.
+ *     @type callable    $screen_function         The callback function that will run when the nav item is clicked.
+ *     @type bool|string $default_subnav_slug     Optional. The slug of the default subnav item to select when the nav
+ *                                                item is clicked.
+ * }
+ * @param string $component Optional. Component that the nav belongs to.
+ * @return bool|BP_Nav_Item Returns false on failure, new nav item on success.
+ */
+function bp_core_create_nav_link( $args = '', $component = 'members' ) {
+	$bp = buddypress();
+
+	$defaults = array(
+		'name'                    => false, // Display name for the nav item.
+		'slug'                    => false, // URL slug for the nav item.
+		'item_css_id'             => false, // The CSS ID to apply to the HTML of the nav item.
+		'show_for_displayed_user' => true,  // When viewing another user does this nav item show up?
+		'site_admin_only'         => false, // Can only site admins see this nav item?
+		'position'                => 99,    // Index of where this nav item should be positioned.
+		'screen_function'         => false, // The name of the function to run when clicked.
+		'default_subnav_slug'     => false  // The slug of the default subnav item to select when clicked.
+	);
+
+	$r = wp_parse_args( $args, $defaults );
+
+	// If we don't have the required info we need, don't create this nav item.
+	if ( empty( $r['name'] ) || empty( $r['slug'] ) ) {
+		return false;
+	}
+
+	// If this is for site admins only and the user is not one, don't create the nav item.
+	if ( ! empty( $r['site_admin_only'] ) && ! bp_current_user_can( 'bp_moderate' ) ) {
+		return false;
+	}
+
+	if ( empty( $r['item_css_id'] ) ) {
+		$r['item_css_id'] = $r['slug'];
+	}
+
+	$nav_item = array(
+		'name'                    => $r['name'],
+		'slug'                    => $r['slug'],
+		'link'                    => trailingslashit( bp_loggedin_user_domain() . $r['slug'] ),
+		'css_id'                  => $r['item_css_id'],
+		'show_for_displayed_user' => $r['show_for_displayed_user'],
+		'position'                => $r['position'],
+		'screen_function'         => &$r['screen_function'],
+		'default_subnav_slug'	  => $r['default_subnav_slug']
+	);
+
+	// Add the item to the nav.
+	$retval = buddypress()->{$component}->nav->add_nav( $nav_item );
+
+	/**
+	 * Fires after a link is added to the main BuddyPress nav.
+	 *
+	 * @since 2.4.0
+	 * @since 2.6.0 Added `$component` parameter.
+	 *
+	 * @param array  $r         Parsed arguments for the nav item.
+	 * @param array  $args      Originally passed in arguments for the nav item.
+	 * @param array  $defaults  Default arguments for a nav item.
+	 * @param string $component Component that the nav belongs to.
+	 */
+	do_action( 'bp_core_create_nav_link', $r, $args, $defaults, $component );
+
+	return $retval;
+}
+
+/**
+ * Register a screen function for an item in the main nav array.
+ *
+ * @since 2.4.0
  *
  * @param array|string $args {
@@ -35,147 +193,4 @@
  * @return bool|null Returns false on failure.
  */
-function bp_core_new_nav_item( $args = '' ) {
-
-	$defaults = array(
-		'name'                    => false, // Display name for the nav item.
-		'slug'                    => false, // URL slug for the nav item.
-		'item_css_id'             => false, // The CSS ID to apply to the HTML of the nav item.
-		'show_for_displayed_user' => true,  // When viewing another user does this nav item show up?
-		'site_admin_only'         => false, // Can only site admins see this nav item?
-		'position'                => 99,    // Index of where this nav item should be positioned.
-		'screen_function'         => false, // The name of the function to run when clicked.
-		'default_subnav_slug'     => false  // The slug of the default subnav item to select when clicked.
-	);
-
-	$r = wp_parse_args( $args, $defaults );
-
-	// First, add the nav item link to the bp_nav array.
-	$created = bp_core_create_nav_link( $r );
-
-	// To mimic the existing behavior, if bp_core_create_nav_link()
-	// returns false, we make an early exit and don't attempt to register
-	// the screen function.
-	if ( false === $created ) {
-		return false;
-	}
-
-	// Then, hook the screen function for the added nav item.
-	$hooked = bp_core_register_nav_screen_function( $r );
-	if ( false === $hooked ){
-		return false;
-	}
-
-	/**
-	 * Fires after adding an item to the main BuddyPress navigation array.
-	 * Note that, when possible, the more specific action hooks
-	 * `bp_core_create_nav_link` or `bp_core_register_nav_screen_function`
-	 * should be used.
-	 *
-	 * @since 1.5.0
-	 *
-	 * @param array $r        Parsed arguments for the nav item.
-	 * @param array $args     Originally passed in arguments for the nav item.
-	 * @param array $defaults Default arguments for a nav item.
-	 */
-	do_action( 'bp_core_new_nav_item', $r, $args, $defaults );
-}
-
-/**
- * Add a link to the main BuddyPress navigation array.
- *
- * @since 2.4.0
- *
- * @param array|string $args {
- *     Array describing the new nav item.
- *     @type string      $name                    Display name for the nav item.
- *     @type string      $slug                    Unique URL slug for the nav item.
- *     @type bool|string $item_css_id             Optional. 'id' attribute for the nav item. Default: the value of `$slug`.
- *     @type bool        $show_for_displayed_user Optional. Whether the nav item should be visible when viewing a
- *                                                member profile other than your own. Default: true.
- *     @type bool        $site_admin_only         Optional. Whether the nav item should be visible only to site admins
- *                                                (those with the 'bp_moderate' cap). Default: false.
- *     @type int         $position                Optional. Numerical index specifying where the item should appear in
- *                                                the nav array. Default: 99.
- *     @type callable    $screen_function         The callback function that will run when the nav item is clicked.
- *     @type bool|string $default_subnav_slug     Optional. The slug of the default subnav item to select when the nav
- *                                                item is clicked.
- * }
- * @return bool|null Returns false on failure.
- */
-function bp_core_create_nav_link( $args = '' ) {
-	$bp = buddypress();
-
-	$defaults = array(
-		'name'                    => false, // Display name for the nav item.
-		'slug'                    => false, // URL slug for the nav item.
-		'item_css_id'             => false, // The CSS ID to apply to the HTML of the nav item.
-		'show_for_displayed_user' => true,  // When viewing another user does this nav item show up?
-		'site_admin_only'         => false, // Can only site admins see this nav item?
-		'position'                => 99,    // Index of where this nav item should be positioned.
-		'screen_function'         => false, // The name of the function to run when clicked.
-		'default_subnav_slug'     => false  // The slug of the default subnav item to select when clicked.
-	);
-
-	$r = wp_parse_args( $args, $defaults );
-
-	// If we don't have the required info we need, don't create this nav item.
-	if ( empty( $r['name'] ) || empty( $r['slug'] ) ) {
-		return false;
-	}
-
-	// If this is for site admins only and the user is not one, don't create the nav item.
-	if ( ! empty( $r['site_admin_only'] ) && ! bp_current_user_can( 'bp_moderate' ) ) {
-		return false;
-	}
-
-	if ( empty( $r['item_css_id'] ) ) {
-		$r['item_css_id'] = $r['slug'];
-	}
-
-	$bp->bp_nav[$r['slug']] = array(
-		'name'                    => $r['name'],
-		'slug'                    => $r['slug'],
-		'link'                    => trailingslashit( bp_loggedin_user_domain() . $r['slug'] ),
-		'css_id'                  => $r['item_css_id'],
-		'show_for_displayed_user' => $r['show_for_displayed_user'],
-		'position'                => $r['position'],
-		'screen_function'         => &$r['screen_function'],
-		'default_subnav_slug'	  => $r['default_subnav_slug']
-	);
-
-	/**
-	 * Fires after a link is added to the main BuddyPress navigation array.
-	 *
-	 * @since 2.4.0
-	 *
-	 * @param array $r        Parsed arguments for the nav item.
-	 * @param array $args     Originally passed in arguments for the nav item.
-	 * @param array $defaults Default arguments for a nav item.
-	 */
-	do_action( 'bp_core_create_nav_link', $r, $args, $defaults );
-}
-
-/**
- * Register a screen function for an item in the main nav array.
- *
- * @since 2.4.0
- *
- * @param array|string $args {
- *     Array describing the new nav item.
- *     @type string      $name                    Display name for the nav item.
- *     @type string      $slug                    Unique URL slug for the nav item.
- *     @type bool|string $item_css_id             Optional. 'id' attribute for the nav item. Default: the value of `$slug`.
- *     @type bool        $show_for_displayed_user Optional. Whether the nav item should be visible when viewing a
- *                                                member profile other than your own. Default: true.
- *     @type bool        $site_admin_only         Optional. Whether the nav item should be visible only to site admins
- *                                                (those with the 'bp_moderate' cap). Default: false.
- *     @type int         $position                Optional. Numerical index specifying where the item should appear in
- *                                                the nav array. Default: 99.
- *     @type callable    $screen_function         The callback function that will run when the nav item is clicked.
- *     @type bool|string $default_subnav_slug     Optional. The slug of the default subnav item to select when the nav
- *                                                item is clicked.
- * }
- * @return bool|null Returns false on failure.
- */
 function bp_core_register_nav_screen_function( $args = '' ) {
 	$bp = buddypress();
@@ -291,18 +306,31 @@
 	$r = wp_parse_args( $args, $defaults );
 
-	if ( $function = $bp->bp_nav[$r['parent_slug']]['screen_function'] ) {
+	// This is specific to Members - it's not available in Groups.
+	$parent_nav = $bp->members->nav->get_primary( array( 'slug' => $r['parent_slug'] ), false );
+
+	if ( ! $parent_nav ) {
+		return ;
+	}
+
+	$parent_nav = reset( $parent_nav );
+
+	if ( ! empty( $parent_nav->screen_function ) ) {
 		// Remove our screen hook if screen function is callable.
-		if ( is_callable( $function ) ) {
-			remove_action( 'bp_screens', $function, 3 );
-		}
-	}
-
-	$bp->bp_nav[$r['parent_slug']]['screen_function'] = &$r['screen_function'];
-
-	if ( bp_is_current_component( $r['parent_slug'] ) ) {
+		if ( is_callable( $parent_nav->screen_function ) ) {
+			remove_action( 'bp_screens', $parent_nav->screen_function, 3 );
+		}
+	}
+
+	// Edit the screen function for the parent nav
+	$bp->members->nav->edit_nav( array(
+		'screen_function'     => &$r['screen_function'],
+		'default_subnav_slug' => $r['subnav_slug'],
+	), $parent_nav->slug );
+
+	if ( bp_is_current_component( $parent_nav->slug ) ) {
 
 		// The only way to tell whether to set the subnav is to peek at the unfiltered_uri
 		// Find the component.
-		$component_uri_key = array_search( $r['parent_slug'], $bp->unfiltered_uri );
+		$component_uri_key = array_search( $parent_nav->slug, $bp->unfiltered_uri );
 
 		if ( false !== $component_uri_key ) {
@@ -340,45 +368,8 @@
 
 /**
- * Sort the navigation menu items.
- *
- * The sorting is split into a separate function because it can only happen
- * after all plugins have had a chance to register their navigation items.
- *
- * @since 1.0.0
- *
- * @return bool|null Returns false on failure.
- */
-function bp_core_sort_nav_items() {
-	$bp = buddypress();
-
-	if ( empty( $bp->bp_nav ) || ! is_array( $bp->bp_nav ) ) {
-		return false;
-	}
-
-	$temp = array();
-
-	foreach ( (array) $bp->bp_nav as $slug => $nav_item ) {
-		if ( empty( $temp[$nav_item['position']] ) ) {
-			$temp[$nav_item['position']] = $nav_item;
-		} else {
-			// Increase numbers here to fit new items in.
-			do {
-				$nav_item['position']++;
-			} while ( ! empty( $temp[$nav_item['position']] ) );
-
-			$temp[$nav_item['position']] = $nav_item;
-		}
-	}
-
-	ksort( $temp );
-	$bp->bp_nav = &$temp;
-}
-add_action( 'wp_head',    'bp_core_sort_nav_items' );
-add_action( 'admin_head', 'bp_core_sort_nav_items' );
-
-/**
- * Add a subnav item to the BuddyPress navigation.
+ * Add an item to secondary navigation of the specified component.
  *
  * @since 1.1.0
+ * @since 2.6.0 Introduced the `$component` parameter.
  *
  * @param array|string $args {
@@ -404,20 +395,47 @@
  *                                          Admin Bar menu for group admins. Default: false.
  * }
+ * @param string $component The component the navigation is attached to. Defaults to 'members'.
  * @return bool|null Returns false on failure.
  */
-function bp_core_new_subnav_item( $args = '' ) {
-
-	// First, add the subnav item link to the bp_options_nav array.
-	$created = bp_core_create_subnav_link( $args );
-
-	// To mimic the existing behavior, if bp_core_create_subnav_link()
-	// returns false, we make an early exit and don't attempt to register
-	// the screen function.
-	if ( false === $created ) {
+function bp_core_new_subnav_item( $args, $component = null ) {
+	// Backward compatibility for plugins using `bp_core_new_subnav_item()` without `$component`
+	// to add group subnav items.
+	if ( null === $component && bp_is_active( 'groups' ) && bp_is_group() && isset( $args['parent_slug'] ) ) {
+		/*
+		 * Assume that this item is intended to belong to the current group if:
+		 * a) the 'parent_slug' is the same as the slug of the current group, or
+		 * b) the 'parent_slug' starts with the slug of the current group, and the members nav doesn't have
+		 *    a primary item with that slug
+		 */
+		$group_slug = bp_get_current_group_slug();
+		if (
+			$group_slug === $args['parent_slug'] ||
+			( 0 === strpos( $args['parent_slug'], $group_slug ) && ! buddypress()->members->nav->get_primary( array( 'slug' => $args['parent_slug'] ), false ) )
+		) {
+			$component = 'groups';
+		}
+	}
+
+	if ( ! $component ) {
+		$component = 'members';
+	}
+
+	if ( ! bp_is_active( $component ) ) {
+		return;
+	}
+
+	// First, register the subnav item in the nav.
+	$subnav_item = bp_core_create_subnav_link( $args, $component );
+
+	/*
+	 * To mimic legacy behavior, if bp_core_create_subnav_link() returns false, we make an
+	 * early exit and don't attempt to register the screen function.
+	 */
+	if ( false === $subnav_item ) {
 		return false;
 	}
 
 	// Then, hook the screen function for the added subnav item.
-	$hooked = bp_core_register_subnav_screen_function( $args );
+	$hooked = bp_core_register_subnav_screen_function( $subnav_item, $component );
 	if ( false === $hooked ) {
 		return false;
@@ -429,4 +447,5 @@
  *
  * @since 2.4.0
+ * @since 2.6.0 Introduced the `$component` parameter. Began returning a BP_Nav_Item object on success.
  *
  * @param array|string $args {
@@ -456,7 +475,8 @@
  *                                          Default: false.
  * }
- * @return bool|null Returns false on failure.
- */
-function bp_core_create_subnav_link( $args = '' ) {
+ * @param string $component The component the navigation is attached to. Defaults to 'members'.
+ * @return bool|BP_Nav_Item Returns false on failure, new nav item on success.
+ */
+function bp_core_create_subnav_link( $args = '', $component = 'members' ) {
 	$bp = buddypress();
 
@@ -484,7 +504,12 @@
 		$r['link'] = trailingslashit( $r['parent_url'] . $r['slug'] );
 
+		$parent_nav = $bp->{$component}->nav->get_primary( array( 'slug' => $r['parent_slug'] ), false );
+
 		// If this sub item is the default for its parent, skip the slug.
-		if ( ! empty( $bp->bp_nav[$r['parent_slug']]['default_subnav_slug'] ) && $r['slug'] == $bp->bp_nav[$r['parent_slug']]['default_subnav_slug'] ) {
-			$r['link'] = trailingslashit( $r['parent_url'] );
+		if ( $parent_nav ) {
+			$parent_nav_item = reset( $parent_nav );
+			if ( ! empty( $parent_nav_item->default_subnav_slug ) && $r['slug'] === $parent_nav_item->default_subnav_slug ) {
+				$r['link'] = trailingslashit( $r['parent_url'] );
+			}
 		}
 	}
@@ -503,4 +528,5 @@
 		'link'              => $r['link'],
 		'slug'              => $r['slug'],
+		'parent_slug'       => $r['parent_slug'],
 		'css_id'            => $r['item_css_id'],
 		'position'          => $r['position'],
@@ -511,5 +537,5 @@
 	);
 
-	$bp->bp_options_nav[$r['parent_slug']][$r['slug']] = $subnav_item;
+	return buddypress()->{$component}->nav->add_nav( $subnav_item );
 }
 
@@ -518,4 +544,5 @@
  *
  * @since 2.4.0
+ * @since 2.6.0 Introduced the `$component` parameter.
  *
  * @param array|string $args {
@@ -542,7 +569,8 @@
  *                                       Default: false.
  * }
+ * @param string $component The component the navigation is attached to. Defaults to 'members'.
  * @return bool|null Returns false on failure.
  */
-function bp_core_register_subnav_screen_function( $args = '' ) {
+function bp_core_register_subnav_screen_function( $args = '', $component = 'members' ) {
 	$bp = buddypress();
 
@@ -556,5 +584,5 @@
 	) );
 
-	/**
+	/*
 	 * Hook the screen function for the added subnav item. But this only needs to
 	 * be done if this subnav item is the current view, and the user has access to the
@@ -569,6 +597,6 @@
 	 *       and this subnav item is the default for the parent item (which we check by
 	 *       comparing this subnav item's screen function with the screen function of the
-	 *       parent nav item in $bp->bp_nav). This condition only arises when viewing a
-	 *       user, since groups should always have an action set.
+	 *       parent nav item in the component's primary nav). This condition only arises
+	 *       when viewing a user, since groups should always have an action set.
 	 */
 
@@ -578,6 +606,8 @@
 	}
 
+	$parent_nav = $bp->{$component}->nav->get_primary( array( 'slug' => $r['parent_slug'] ), false );
+
 	// If we *do* meet condition (2), then the added subnav item is currently being requested.
-	if ( ( bp_current_action() && bp_is_current_action( $r['slug'] ) ) || ( bp_is_user() && ! bp_current_action() && ( $r['screen_function'] == $bp->bp_nav[$r['parent_slug']]['screen_function'] ) ) ) {
+	if ( ( bp_current_action() && bp_is_current_action( $r['slug'] ) ) || ( bp_is_user() && ! bp_current_action() && ! empty( $parent_nav->screen_function ) && $r['screen_function'] == $parent_nav->screen_function ) ) {
 
 		// If this is for site admins only and the user is not one, don't create the subnav item.
@@ -586,5 +616,5 @@
 		}
 
-		$hooked = bp_core_maybe_hook_new_subnav_screen_function( $r );
+		$hooked = bp_core_maybe_hook_new_subnav_screen_function( $r, $component );
 
 		// If redirect args have been returned, perform the redirect now.
@@ -599,9 +629,12 @@
  *
  * @since 2.1.0
- *
- * @param array $subnav_item The subnav array added to bp_options_nav in `bp_core_new_subnav_item()`.
+ * @since 2.6.0 Introduced the `$component` parameter.
+ *
+ * @param array  $subnav_item The subnav array added to the secondary navigation of
+ *                            the component in bp_core_new_subnav_item().
+ * @param string $component   The component the navigation is attached to. Defaults to 'members'.
  * @return array
  */
-function bp_core_maybe_hook_new_subnav_screen_function( $subnav_item ) {
+function bp_core_maybe_hook_new_subnav_screen_function( $subnav_item, $component = 'members' ) {
 	$retval = array(
 		'status' => '',
@@ -646,8 +679,13 @@
 			} elseif ( bp_is_user() ) {
 
+				$parent_nav_default = $bp->{$component}->nav->get_primary( array( 'slug' => $bp->default_component ), false );
+				if ( $parent_nav_default ) {
+					$parent_nav_default_item = reset( $parent_nav_default );
+				}
+
 				// Redirect to the displayed user's default
 				// component, as long as that component is
 				// publicly accessible.
-				if ( bp_is_my_profile() || ! empty( $bp->bp_nav[ $bp->default_component ]['show_for_displayed_user'] ) ) {
+				if ( bp_is_my_profile() || ( isset( $parent_nav_default_item ) && $parent_nav_default_item->show_for_displayed_user ) ) {
 					$message     = __( 'You do not have access to this page.', 'buddypress' );
 					$redirect_to = bp_displayed_user_domain();
@@ -692,56 +730,30 @@
 
 /**
- * Sort all subnavigation arrays.
- *
- * @since 1.1.0
- *
- * @return bool|null Returns false on failure.
- */
-function bp_core_sort_subnav_items() {
+ * Check whether a given nav item has subnav items.
+ *
+ * @since 1.5.0
+ * @since 2.6.0 Introduced the `$component` parameter.
+ *
+ * @param string $nav_item  The slug of the top-level nav item whose subnav items you're checking.
+ *                          Default: the current component slug.
+ * @param string $component The component the navigation is attached to. Defaults to 'members'.
+ * @return bool $has_subnav True if the nav item is found and has subnav items; false otherwise.
+ */
+function bp_nav_item_has_subnav( $nav_item = '', $component = 'members' ) {
 	$bp = buddypress();
 
-	if ( empty( $bp->bp_options_nav ) || !is_array( $bp->bp_options_nav ) )
-		return false;
-
-	foreach ( (array) $bp->bp_options_nav as $parent_slug => $subnav_items ) {
-		if ( !is_array( $subnav_items ) )
-			continue;
-
-		foreach ( (array) $subnav_items as $subnav_item ) {
-			if ( empty( $temp[$subnav_item['position']]) )
-				$temp[$subnav_item['position']] = $subnav_item;
-			else {
-				// Increase numbers here to fit new items in.
-				do {
-					$subnav_item['position']++;
-				} while ( !empty( $temp[$subnav_item['position']] ) );
-
-				$temp[$subnav_item['position']] = $subnav_item;
-			}
-		}
-		ksort( $temp );
-		$bp->bp_options_nav[$parent_slug] = &$temp;
-		unset( $temp );
-	}
-}
-add_action( 'wp_head',    'bp_core_sort_subnav_items' );
-add_action( 'admin_head', 'bp_core_sort_subnav_items' );
-
-/**
- * Check whether a given nav item has subnav items.
- *
- * @since 1.5.0
- *
- * @param string $nav_item The slug of the top-level nav item whose subnav items you're checking.
- *                         Default: the current component slug.
- * @return bool $has_subnav True if the nav item is found and has subnav items; false otherwise.
- */
-function bp_nav_item_has_subnav( $nav_item = '' ) {
-	$bp = buddypress();
-
-	if ( !$nav_item )
+	if ( ! isset( $bp->{$component}->nav ) ) {
+		return false;
+	}
+
+	if ( ! $nav_item ) {
 		$nav_item = bp_current_component();
 
-	$has_subnav = isset( $bp->bp_options_nav[$nav_item] ) && count( $bp->bp_options_nav[$nav_item] ) > 0;
+		if ( bp_is_group() ) {
+			$nav_item = bp_current_item();
+		}
+	}
+
+	$has_subnav = (bool) $bp->{$component}->nav->get_secondary( array( 'parent_slug' => $nav_item ), false );
 
 	/**
@@ -757,50 +769,44 @@
 
 /**
- * Remove a nav item from the navigation array.
+ * Deletes an item from the primary navigation of the specified component.
  *
  * @since 1.0.0
- *
- * @param int $parent_id The slug of the parent navigation item.
- * @return bool Returns false on failure, ie if the nav item can't be found.
- */
-function bp_core_remove_nav_item( $parent_id ) {
+ * @since 2.6.0 Introduced the `$component` parameter.
+ *
+ * @param string $slug      The slug of the primary navigation item.
+ * @param string $component The component the navigation is attached to. Defaults to 'members'.
+ * @return bool Returns false on failure, True on success.
+ */
+function bp_core_remove_nav_item( $slug, $component = null ) {
 	$bp = buddypress();
 
-	// Unset subnav items for this nav item.
-	if ( isset( $bp->bp_options_nav[$parent_id] ) && is_array( $bp->bp_options_nav[$parent_id] ) ) {
-		foreach( (array) $bp->bp_options_nav[$parent_id] as $subnav_item ) {
-			bp_core_remove_subnav_item( $parent_id, $subnav_item['slug'] );
-		}
-	}
-
-	if ( empty( $bp->bp_nav[ $parent_id ] ) )
-		return false;
-
-	if ( $function = $bp->bp_nav[$parent_id]['screen_function'] ) {
-		// Remove our screen hook if screen function is callable.
-		if ( is_callable( $function ) ) {
-			remove_action( 'bp_screens', $function, 3 );
-		}
-	}
-
-	unset( $bp->bp_nav[$parent_id] );
-}
-
-/**
- * Remove a subnav item from the navigation array.
- *
- * @since 1.0.0
- *
- * @param string $parent_id The slug of the parent navigation item.
- * @param string $slug      The slug of the subnav item to be removed.
- */
-function bp_core_remove_subnav_item( $parent_id, $slug ) {
-	$bp = buddypress();
-
-	$screen_function = isset( $bp->bp_options_nav[$parent_id][$slug]['screen_function'] )
-		? $bp->bp_options_nav[$parent_id][$slug]['screen_function']
-		: false;
-
-	if ( ! empty( $screen_function ) ) {
+	// Backward compatibility for removing group nav items using the group slug as `$parent_slug`.
+	if ( ! $component && bp_is_active( 'groups' ) && isset( $bp->groups->nav ) ) {
+		if ( $bp->groups->nav->get_primary( array( 'slug' => $slug ) ) ) {
+			return bp_core_remove_nav_item( $slug, 'groups' );
+		}
+	}
+
+	if ( ! $component ) {
+		$component = 'members';
+	}
+
+	if ( ! isset( $bp->{$component}->nav ) ) {
+		return false;
+	}
+
+	$screen_functions = $bp->{$component}->nav->delete_nav( $slug );
+
+	// Reset backcompat nav items so that subsequent references will be correct.
+	if ( buddypress()->do_nav_backcompat ) {
+		$bp->bp_nav->reset();
+		$bp->bp_options_nav->reset();
+	}
+
+	if ( ! is_array( $screen_functions ) ) {
+		return false;
+	}
+
+	foreach ( $screen_functions as $screen_function ) {
 		// Remove our screen hook if screen function is callable.
 		if ( is_callable( $screen_function ) ) {
